#!/usr/bin/env python3.12
# tests

import asyncio
import sys
sys.path.insert(1, '.')
import sources.cache, sources.genius, sources.aggregate, sources.lrclib

test_artist = "hopsin"
test_song = "ill mind of fssfgdfhopsin 5"

async def test_cache(artist, song):
    cache = sources.cache.Cache()
    result = await cache.search(artist, song)
    if not result:
        print(f"Could not find {artist} - {song}!")
        return
    print(result.dict())
        
        # print(f"artist: {ret_artist}\nsong: {ret_song}:\n{ret_lyr}")
    # print(result)

async def test_genius(artist=None, song=None):
    if not artist or not song:
        artist = test_artist
        song = test_song
        genius = sources.genius.Genius()
        result = await genius.search(artist, song)
        print(result)

async def test_lrclib(artist=None, song=None):
    if not artist or not song:
        artist = test_artist
        song = test_song
        lrclib = sources.lrclib.LRCLib()
        result = await lrclib.search(artist, song)
        print(result)

async def test_aggregate(artist=None, song=None):
    if not artist or not song:
        artist = test_artist
        song = test_song
        aggregate = sources.aggregate.Aggregate()
        result = await aggregate.search(artist, song)
        print(result.dict())



loop = asyncio.new_event_loop()
# loop.run_until_complete(test_genius())
# loop.run_until_complete(test_lrclib())
# loop.run_until_complete(test_cache(artist=test_artist, song=test_song))
loop.run_until_complete(test_aggregate())
